import Skypager from '.'
describe('Skypager Helpers', function() {
  describe('Models', function() {
    const project = Skypager.load(process.cwd(), {
      sync: false
    })

    it('makes models available', function() {
      project.models.available.should.not.be.empty
    })

    it('builds a map of which objects were found at which route', function() {
      const instanceObjectMap = project.model('Helper').routeResultsMap
      instanceObjectMap.should.be.an('object').with.property('*/config-builders/*.js').that.is.an('array').that.is.not.empty
    })

    it('gives us all of the instances keyed by their document id', function() {
      project.model('Helper').should.have.property('instances').that.is.an('object')
        .that.has.property('src/document-types/babel-es6')
        .that.is.an('object')
        .that.has.a.property('file').that.is.an('object')
    })

    it('applies exclusion rules', function() {
      const model = project.model('Helper', { exclude: /config-builders/ })

      model.should.have.property('exclude').that.is.an('array')
      model.resultIds.filter(id => id.match(/config-builders/)).should.be.empty
    })

    it('applies inclusion rules', function() {
      project.model('Helper', { include: /config-builders/ }).resultIds.filter(id => id.match(/config-builders/)).should.not.be.empty
    })
  })

})
